Index: issm/trunk/src/m/classes/organizer.m
===================================================================
--- issm/trunk/src/m/classes/organizer.m	(revision 13405)
+++ issm/trunk/src/m/classes/organizer.m	(revision 13975)
@@ -10,5 +10,4 @@
 %      org = organizer(varargin)
 %
-%
 %   Examples:
 %      org = organizer('repository','Models/','prefix','AGU2015','steps',0);  %build an empty organizer object with a given repository
@@ -16,151 +15,151 @@
 classdef organizer
     properties (SetAccess=private) 
-		 % {{{
-		 currentstep   =0;
-	 end
+		% {{{
+		currentstep   =0;
+	end
     properties (SetAccess=public) 
-		 repository    ='./';
-		 prefix        ='model.';
-		 trunkprefix   ='';
-		 steps         =[];
-		 requestedsteps=[0];
-		 %}}}
-	 end
-	 methods
-		 function org=organizer(varargin) % {{{
+		repository    ='./';
+		prefix        ='model.';
+		trunkprefix   ='';
+		steps         =[];
+		requestedsteps=[0];
+		%}}}
+	end
+	methods
+		function org=organizer(varargin) % {{{
 
-			 %process options
-			 options=pairoptions(varargin{:});
+			%process options
+			options=pairoptions(varargin{:});
 
-			 %Get prefix
-			 prefix=getfieldvalue(options,'prefix','model.');
-			 if ~ischar(prefix),                            error('prefix is not a string'); end
-			 if ~strcmp(regexprep(prefix,'\s+',''),prefix), error('prefix should not have any white space'); end
-			 org.prefix=prefix;
+			%Get prefix
+			prefix=getfieldvalue(options,'prefix','model.');
+			if ~ischar(prefix),                            error('prefix is not a string'); end
+			if ~strcmp(regexprep(prefix,'\s+',''),prefix), error('prefix should not have any white space'); end
+			org.prefix=prefix;
 
-			 %Get repository
-			 repository=getfieldvalue(options,'repository','./');
-			 if ~ischar(repository),        error('repository is not a string'); end
-			 if exist(repository,'dir')~=7, error(['Directory ' repository ' not found']), end
-			 org.repository=repository;
+			%Get repository
+			repository=getfieldvalue(options,'repository','./');
+			if ~ischar(repository),        error('repository is not a string'); end
+			if exist(repository,'dir')~=7, error(['Directory ' repository ' not found']), end
+			org.repository=repository;
 
-			 %Get repository
-			 org.requestedsteps=getfieldvalue(options,'steps',0);
+			%Get steps
+			org.requestedsteps=getfieldvalue(options,'steps',0);
 
-			 %Get trunk prefix (only if provided by user)
-			 if exist(options,'trunkprefix'),
-				 trunkprefix=getfieldvalue(options,'trunkprefix','');
-				 if ~ischar(trunkprefix),                                 error('trunkprefix is not a string'); end
-				 if ~strcmp(regexprep(trunkprefix,'\s+',''),trunkprefix), error('trunkprefix should not have any white space'); end
-				 org.trunkprefix=trunkprefix;
-			 end
-		 end
-		 %}}}
-		 function disp(org) % {{{
-			 disp(sprintf('   Repository: ''%s''',org.repository));
-			 disp(sprintf('   Prefix:     ''%s''',org.prefix));
-			 if isempty(org.steps)
-				 disp('   no step');
-			 else
-				 for i=1:length(org.steps),
-					 disp(sprintf('   step #%2i: ''%s''',org.steps(i).id,org.steps(i).string));
-				 end
-			 end
-		 end
-		 %}}}
-		 function md=load(org,string),% {{{
+			%Get trunk prefix (only if provided by user)
+			if exist(options,'trunkprefix'),
+				trunkprefix=getfieldvalue(options,'trunkprefix','');
+				if ~ischar(trunkprefix),                                 error('trunkprefix is not a string'); end
+				if ~strcmp(regexprep(trunkprefix,'\s+',''),trunkprefix), error('trunkprefix should not have any white space'); end
+				org.trunkprefix=trunkprefix;
+			end
+		end
+		%}}}
+		function disp(org) % {{{
+			disp(sprintf('   Repository: ''%s''',org.repository));
+			disp(sprintf('   Prefix:     ''%s''',org.prefix));
+			if isempty(org.steps)
+				disp('   no step');
+			else
+				for i=1:length(org.steps),
+					disp(sprintf('   step #%2i: ''%s''',org.steps(i).id,org.steps(i).string));
+				end
+			end
+		end
+		%}}}
+		function md=load(org,string),% {{{
 
-			 %Get model path
-			 if ~ischar(string), error('argument provided is not a string'); end
-			 path=[org.repository '/' org.prefix string];
+			%Get model path
+			if ~ischar(string), error('argument provided is not a string'); end
+			path=[org.repository '/' org.prefix string];
 
-			 %figure out if the model is there
-			 if exist(path,'file'),
-				 struc=load(path,'-mat');
-				 name=char(fieldnames(struc));
-				 md=struc.(name);
-				 if nargout,
-					 varargout{1}=md;
-				 end
-			 else
-				 error(['Could not find ' path ]);
-			 end
-		 end%}}}
-		 function md=loadmodel(org,string),% {{{
+			%figure out if the model is there
+			if exist(path,'file'),
+				struc=load(path,'-mat');
+				name=char(fieldnames(struc));
+				md=struc.(name);
+				if nargout,
+					varargout{1}=md;
+				end
+			else
+				error(['Could not find ' path ]);
+			end
+		end%}}}
+		function md=loadmodel(org,string),% {{{
 
-			 %Get model path
-			 if ~ischar(string), error('argument provided is not a string'); end
-			 path=[org.repository '/' org.prefix string];
+			%Get model path
+			if ~ischar(string), error('argument provided is not a string'); end
+			path=[org.repository '/' org.prefix string];
 
-			 %figure out if the model is there, otherwise, we have to use the default path supplied by user.
-			 if exist(path,'file') | exist([path '.mat'],'file'),
-				 md=loadmodel(path);
-				 return;
-			 end
+			%figure out if the model is there, otherwise, we have to use the default path supplied by user.
+			if exist(path,'file') | exist([path '.mat'],'file'),
+				md=loadmodel(path);
+				return;
+			end
 
-			 %If we are here, the model has not been found. Try trunk prefix if provided
-			 if ~isempty(org.trunkprefix),
-				 path2=[org.repository '/' org.trunkprefix string];
-				 if ~exist(path2,'file'),
-					 error(['Could neither find ' path ', nor ' path2]);
-				 else
-					 disp(['--> Branching ' org.prefix ' from trunk ' org.trunkprefix]);
-					 md=loadmodel(path2);
-					 return;
-				 end
-			 else
-				 error(['Could not find ' path ]);
-			 end
-		 end%}}}
-		 function bool=perform(org,string) % {{{
-			 
-			 bool=false;
+			%If we are here, the model has not been found. Try trunk prefix if provided
+			if ~isempty(org.trunkprefix),
+				path2=[org.repository '/' org.trunkprefix string];
+				if ~exist(path2,'file'),
+					error(['Could find neither ' path ', nor ' path2]);
+				else
+					disp(['--> Branching ' org.prefix ' from trunk ' org.trunkprefix]);
+					md=loadmodel(path2);
+					return;
+				end
+			else
+				error(['Could not find ' path ]);
+			end
+		end%}}}
+		function bool=perform(org,string) % {{{
 
-			 %Some checks
-			 if ~ischar(string),                            error('Step provided should be a string'); end
-			 if ~strcmp(regexprep(string,'\s+',''),string), error('Step provided should not have any white space'); end
-			 if (org.currentstep>0 & ismember({string},{org.steps.string})) 
-				 error(['Step ' string ' already present. Change name']); 
-			 end
+			bool=false;
 
-			 %Add step
-			 org.steps(end+1).id=length(org.steps)+1;
-			 org.steps(end).string=string;
-			 org.currentstep=org.currentstep+1;
+			%Some checks
+			if ~ischar(string),                            error('Step provided should be a string'); end
+			if ~strcmp(regexprep(string,'\s+',''),string), error('Step provided should not have any white space'); end
+			if (org.currentstep>0 & ismember({string},{org.steps.string})) 
+				error(['Step ' string ' already present. Change name']); 
+			end
 
-			 %if requestedsteps = 0, print all steps in org 
-			 if any(org.requestedsteps==0),
-				 if org.currentstep==1,
-					 disp(sprintf('   prefix: %s',org.prefix));
-				 end
-				 disp(sprintf('   step #%2i : %s',org.steps(org.currentstep).id,org.steps(org.currentstep).string));
-			 end
+			%Add step
+			org.steps(end+1).id=length(org.steps)+1;
+			org.steps(end).string=string;
+			org.currentstep=org.currentstep+1;
 
-			 %Ok, now if currentstep is a member of steps, return true
-			 if ismember(org.currentstep,org.requestedsteps),
-				 disp(sprintf('\n   step #%i : %s\n',org.steps(org.currentstep).id,org.steps(org.currentstep).string));
-				 bool=true;
-			 end
+			%if requestedsteps = 0, print all steps in org 
+			if any(org.requestedsteps==0),
+				if org.currentstep==1,
+					disp(sprintf('   prefix: %s',org.prefix));
+				end
+				disp(sprintf('   step #%2i : %s',org.steps(org.currentstep).id,org.steps(org.currentstep).string));
+			end
 
-			 %assign org back to calling workspace
-			 assignin('caller',inputname(1),org);
+			%Ok, now if currentstep is a member of steps, return true
+			if ismember(org.currentstep,org.requestedsteps),
+				disp(sprintf('\n   step #%i : %s\n',org.steps(org.currentstep).id,org.steps(org.currentstep).string));
+				bool=true;
+			end
 
-		 end%}}}
-		 function savemodel(org,md) % {{{
+			%assign org back to calling workspace
+			assignin('caller',inputname(1),org);
 
-			 %check
-			 if (org.currentstep==0), error('Cannot save model because organizer (org) is empty! Make sure you did not skip any perform call'); end
-			 if (org.currentstep>length(org.steps)), error('Cannot save model because organizer (org) is not up to date!'); end
+		end%}}}
+		function savemodel(org,md) % {{{
 
-			 name=[org.repository '/' org.prefix org.steps(org.currentstep).string ];
-			 disp(['saving model as: ' name]);
-			 
-			 %check that md is a model
-			 if ~isa(md,'model'), warning('third argument is not a model'); end
-			 if (org.currentstep>length(org.steps)), error(['organizer error message: element with id ' num2str(org.currentstep) ' not found']); end
+			%check
+			if (org.currentstep==0), error('Cannot save model because organizer (org) is empty! Make sure you did not skip any perform call'); end
+			if (org.currentstep>length(org.steps)), error('Cannot save model because organizer (org) is not up to date!'); end
 
-			 %save model
-			 save(name,'md','-v7.3');
-		 end%}}}
+			name=[org.repository '/' org.prefix org.steps(org.currentstep).string ];
+			disp(['saving model as: ' name]);
+
+			%check that md is a model
+			if ~isa(md,'model'), warning('second argument is not a model'); end
+			if (org.currentstep>length(org.steps)), error(['organizer error message: element with id ' num2str(org.currentstep) ' not found']); end
+
+			%save model
+			save(name,'md','-v7.3');
+		end%}}}
 	end
 end
Index: issm/trunk/src/m/classes/organizer.py
===================================================================
--- issm/trunk/src/m/classes/organizer.py	(revision 13975)
+++ issm/trunk/src/m/classes/organizer.py	(revision 13975)
@@ -0,0 +1,176 @@
+import os.path
+from collections import OrderedDict
+from pairoptions import *
+from loadvars import *
+from loadmodel import *
+from savevars import *
+from model import model
+
+class organizer(object):
+	"""
+	ORGANIZER class definition
+
+	   Supported options:
+	      repository: directory where all models will be saved
+	      prefix:     prefix for saved model names
+	      steps:      requested steps
+	      trunkprefix:prefix of previous run with a different prefix. Used to branch.
+
+	   Usage:
+	      org = organizer(varargin)
+
+	   Examples:
+	      org = organizer('repository','Models/','prefix','AGU2015','steps',0);  %build an empty organizer object with a given repository
+	"""
+
+	def __init__(self,*args):    # {{{
+		self._currentstep  =0
+		self.repository    ='./'
+		self.prefix        ='model.'
+		self.trunkprefix   =''
+		self.steps         =[]
+		self.requestedsteps=[0]
+
+		#process options
+		options=pairoptions(*args)
+
+		#Get prefix
+		prefix=options.getfieldvalue('prefix','model.')
+		if not isinstance(prefix,(str,unicode)):
+			raise TypeError("prefix is not a string")
+		if not strcmp(prefix,prefix.strip()) or len(prefix.split()) > 1:
+			raise TypeError("prefix should not have any white space")
+		self.prefix=prefix
+
+		#Get repository
+		repository=options.getfieldvalue('repository','./')
+		if not isinstance(repository,(str,unicode)):
+			raise TypeError("repository is not a string")
+		if not os.path.isdir(repository):
+			raise IOError("Directory '%s' not found" % repository)
+		self.repository=repository
+
+		#Get steps
+		self.requestedsteps=options.getfieldvalue('steps',[0])
+
+		#Get trunk prefix (only if provided by user)
+		if options.exist('trunkprefix'):
+			trunkprefix=options.getfieldvalue('trunkprefix','')
+			if not isinstance(trunkprefix,(str,unicode)):
+				raise TypeError("trunkprefix is not a string")
+			if not strcmp(trunkprefix,trunkprefix.strip()) or len(trunkprefix.split()) > 1:
+				raise TypeError("trunkprefix should not have any white space")
+			self.trunkprefix=trunkprefix
+	#}}}
+
+	def __repr__(self):    # {{{
+		s =""
+
+		s+="%s\n" % "   Repository: '%s'" % self.repository
+		s+="%s\n" % "   Prefix:     '%s'" % self.prefix
+		if not self.steps:
+			s+="%s\n" % "   no step"
+		else:
+			for step in self.steps:
+				s+="%s\n" % "   step #%2i: '%s'",step['id'],step['string']
+	#}}}
+
+	def load(self,string):    # {{{
+
+		#Get model path
+		if not isinstance(string,(str,unicode)):
+			raise TypeError("argument provided is not a string")
+		path=os.path.join(self.repository,self.prefix+string)
+
+		#figure out if the model is there
+		if os.path.exists(path):
+			struc=loadvars(path)
+			name=name=[key for key in struc.iterkeys()]
+			md=struc.name[0]
+		else:
+			raise IOError("Could not find '%s'" % path)
+
+		return md
+	#}}}
+
+	def loadmodel(self,string):    # {{{
+
+		#Get model path
+		if not isinstance(string,(str,unicode)):
+			raise TypeError("argument provided is not a string")
+		path=os.path.join(self.repository,self.prefix+string)
+
+		#figure out if the model is there, otherwise, we have to use the default path supplied by user.
+		if os.path.exists(path):
+			md=loadmodel(path)
+			return md
+
+		#If we are here, the model has not been found. Try trunk prefix if provided
+		if self.trunkprefix:
+			path2=os.path.join(self.repository,self.trunkprefix+string)
+			if not os.path.exists(path2):
+				raise IOError("Could find neither '%s' nor '%s'" % (path,path2))
+			else:
+				print "--> Branching '%s' from trunk '%s'" % (self.prefix,self.trunkprefix)
+				md=loadmodel(path2)
+				return md
+		else:
+			raise IOerror("Could not find '%s'" % path)
+	#}}}
+
+	def perform(self,string):    # {{{
+
+		bool=False
+
+		#Some checks
+		if not isinstance(string,(str,unicode)):
+			raise TypeError("Step provided should be a string")
+		if not strcmp(string,string.strip()) or len(string.split()) > 1:
+			raise TypeError("Step provided should not have any white space")
+		if self._currentstep>0 and string in [step['string'] for step in self.steps]:
+			raise RuntimeError("Step '%s' already present. Change name" % string) 
+
+		#Add step
+		self.steps.append(OrderedDict())
+		self.steps[-1]['id']=len(self.steps)
+		self.steps[-1]['string']=string
+		self._currentstep+=1
+
+		#if requestedsteps = 0, print all steps in self 
+		if 0 in self.requestedsteps:
+			if self._currentstep==1:
+				print "   prefix: %s" % self.prefix
+			print "   step #%i : %s" % (self.steps[self._currentstep-1]['id'],self.steps[self._currentstep-1]['string'])
+
+		#Ok, now if _currentstep is a member of steps, return true
+		if self._currentstep in self.requestedsteps:
+			print "\n   step #%i : %s\n" % (self.steps[self._currentstep-1]['id'],self.steps[self._currentstep-1]['string'])
+			bool=True
+
+		#assign self back to calling workspace
+		# (no need, since Python modifies class instance directly)
+
+		return bool
+	#}}}
+
+	def savemodel(self,md):    # {{{
+
+		#check
+		if self._currentstep==0:
+			raise RuntimeError("Cannot save model because organizer (org) is empty! Make sure you did not skip any perform call")
+		if self._currentstep>len(self.steps):
+			raise RuntimeError("Cannot save model because organizer (org) is not up to date!")
+
+		name=os.path.join(self.repository,self.prefix+self.steps[self._currentstep-1]['string'])
+		print "saving model as: '%s'" % name
+
+		#check that md is a model
+		if not isinstance(md,model):
+			print("second argument is not a model")
+		if self._currentstep>len(self.steps):
+			raise RuntimeError("organizer error message: element with id %d not found" % self._currentstep)
+
+		#save model
+		savevars(name,'md',md)
+	#}}}
+
Index: issm/trunk/src/m/classes/pairoptions.m
===================================================================
--- issm/trunk/src/m/classes/pairoptions.m	(revision 13405)
+++ issm/trunk/src/m/classes/pairoptions.m	(revision 13975)
@@ -175,5 +175,5 @@
 
 			%some argument checking: 
-			if nargin~=2 & nargin~=3,
+			if nargin~=2 && nargin~=3,
 				help getfieldvalue
 				error('getfieldvalue error message: bad usage');
@@ -185,9 +185,8 @@
 
 			%Recover option
-			for i=1:size(obj.list,1),
-				if strcmpi(obj.list{i,1},field)
-					value=obj.list{i,2};
-					return
-				end
+			pos=find(strcmpi(obj.list(:,1),field));
+			if ~isempty(pos),
+				value=obj.list{pos(1),2}; %ignore extra entry
+				return;
 			end
 
Index: issm/trunk/src/m/classes/pairoptions.py
===================================================================
--- issm/trunk/src/m/classes/pairoptions.py	(revision 13405)
+++ issm/trunk/src/m/classes/pairoptions.py	(revision 13975)
@@ -41,5 +41,5 @@
 			else:
 				#option is not a string, ignore it
-				print "WARNING: option number %d '%s' is not a string and will be ignored." % (i+1,type(arg[2*i]))
+				print "WARNING: option number %d is not a string and will be ignored." % (i+1)
 	# }}}
 
@@ -53,5 +53,5 @@
 
 	def addfielddefault(self,field,value):    # {{{
-		"""ADDFIELDDEFAULT - add a field to an options list if it does not exist"""
+		"""ADDFIELDDEFAULT - add a field to an options list if it does not already exist"""
 		if isinstance(field,(str,unicode)):
 			if field not in self.list:
@@ -128,15 +128,17 @@
 	# }}}
 
-#	function num = fieldoccurences(obj,field), % {{{
-#	%FIELDOCCURENCES - get number of occurence of a field
-#
-#		%check input 
-#		if ~ischar(field),
-#			error('fieldoccurences error message: field should be a string');
-#		end
-#
-#		%get number of occurence
-#		num=sum(strcmpi(field,obj.list(:,1)));
-#	end % }}}
+	#def fieldoccurences(self,field): #{{{
+	#	'''
+	#	FIELDOCCURENCES - get number of occurence of a field
+	#	'''
+	#
+	#	#check input 
+	#	if not isinstance(field,(str,unicode)):
+	#		raise TypeError("fieldoccurences error message: field should be a string")
+
+	#	#get number of occurence
+	#	# ??
+	#	#return num
+	#	#% }}}
 
 	def getfieldvalue(self,field,default=None):    # {{{
Index: issm/trunk/src/m/classes/plotoptions.py
===================================================================
--- issm/trunk/src/m/classes/plotoptions.py	(revision 13975)
+++ issm/trunk/src/m/classes/plotoptions.py	(revision 13975)
@@ -0,0 +1,127 @@
+from collections import OrderedDict, Counter, defaultdict
+from pairoptions import *
+
+class plotoptions(object):
+	'''
+	PLOTOPTIONS class definition
+
+		Usage:
+			plotoptions=plotoptions(*arg)
+	'''
+
+	def __init__(self,*arg):
+		self.numberofplots = 0
+		self.figurenumber  = 1
+		self.list          = OrderedDict()
+
+		self.buildlist(*arg)
+
+	def __repr__(self): #{{{
+		s="\n"
+		s+="	numberofplots: %i\n" % self.numberofplots
+		s+="	figurenumber: %i\n"  % self.figurenumber
+		if self.list:
+			s+="	list: (%ix%i)\n" % (len(self.list),2)
+			for item in self.list.iteritems():
+				#s+="	options of plot number %i\n" % item
+				if   isinstance(item[1],(str,unicode)):
+					s+="	field: %-10s value: '%s'\n" % (item[0],item[1])
+				elif isinstance(item[1],(bool,int,long,float)):
+					s+="	field: %-10s value: '%g'\n" % (item[0],item[1])
+				else:
+					s+="	field: %-10s value: '%s'\n" % (item[0],item[1])
+		else:
+			s+="	list: empty\n"
+		return s
+	#}}}
+	def buildlist(self,*arg): #{{{
+		#check length of input
+		if len(arg) % 2:
+			raise TypeError('error: an even number of options is required')
+
+		#go through args and build list (like pairoptions)
+		rawoptions=pairoptions(*arg)
+		numoptions=len(arg)/2
+		rawlist=[] # cannot be a dict since they do not support duplicate keys
+
+		for i in xrange(numoptions):
+			if isinstance(arg[2*i],(str,unicode)):
+				rawlist.append([arg[2*i],arg[2*i+1]])
+			else:
+				#option is not a string, ignore it
+				print "WARNING: option number %d is not a string and will be ignored." % (i+1)
+
+		#get figure number 
+		self.figurenumber=rawoptions.getfieldvalue('figure',1)
+
+		#get number of subplots 
+		numberofplots=Counter(x for sublist in rawlist for x in sublist if isinstance(x,(str,unicode)))['data']
+		self.numberofplots=numberofplots
+
+		#figure out whether alloptions flag is on
+		if rawoptions.getfieldvalue('alloptions','off') is 'on':
+			allflag=1
+		else:
+			allflag=0
+
+		#initialize self.list (will need a list of dict's (or nested dict) for numberofplots>1)
+		#self.list=defaultdict(dict)
+		for i in xrange(numberofplots):
+			self.list[i]=pairoptions()
+
+		#process plot options
+		for i in xrange(len(rawlist)):
+
+			#if alloptions flag is on, apply to all plots
+			if (allflag and 'data' not in rawlist[i][0] and '#' not in rawlist[i][0]):
+				
+				for j in xrange(numberofplots):
+					self.list[j].addfield(rawlist[i][0],rawlist[i][1])
+
+			elif '#' in rawlist[i][0]:
+
+				#get subplots associated
+				string=rawlist[i][0].split('#')
+				plotnums=string[-1].split(',')
+				field=string[0]
+
+				#loop over plotnums
+				for k in xrange(len(plotnums)):
+					plotnum=plotnums[k]
+
+					#Empty
+					if not plotnum: continue
+
+					# '#all'
+					elif 'all' in plotnum:
+						for j in xrange(numberofplots):
+							self.list[j].addfield(field,rawlist[i][1])
+
+					# '#i-j'
+					elif '-' in plotnum:
+						nums=plotnum.split('-')
+						if len(nums)!=2: continue
+						if False in [x.isdigit() for x in nums]:
+							raise ValueError('error: in option i-j both i and j must be integers')
+						for j in xrange(int(nums[0])-1,int(nums[1])):
+							self.list[j].addfield(field,rawlist[i][1])	
+
+					# Deal with #i
+					else:
+						#assign to subplot
+						if int(plotnum)>numberofplots:
+							raise ValueError('error: %s cannot be assigned %d which exceeds the number of subplots' % (field,plotnum))
+						self.list[int(plotnum)-1].addfield(field,rawlist[i][1])
+			else:
+				
+				#go through all subplots and assign key-value pairs
+				j=0
+				while j <= numberofplots-1:
+					if not self.list[j].exist(rawlist[i][0]):
+						self.list[j].addfield(rawlist[i][0],rawlist[i][1])
+						break
+					else:
+						j=j+1
+				if j+1>numberofplots:
+					print "WARNING: too many instances of '%s' in options" % rawlist[i][0]
+	#}}}
Index: issm/trunk/src/m/classes/prognostic.m
===================================================================
--- issm/trunk/src/m/classes/prognostic.m	(revision 13405)
+++ issm/trunk/src/m/classes/prognostic.m	(revision 13975)
@@ -12,4 +12,5 @@
 		 vertex_pairing         = NaN;
 		 penalty_factor         = 0;
+		 requested_outputs      = NaN;
 	end
 	methods
@@ -45,4 +46,7 @@
 			md = checkfield(md,'prognostic.stabilization','values',[0 1 2 3]);
 			md = checkfield(md,'prognostic.min_thickness','>',0);
+			if ~isempty(md.prognostic.requested_outputs),
+				md = checkfield(md,'prognostic.requested_outputs','size',[NaN 1]);
+			end
 
 		end % }}}
@@ -57,4 +61,5 @@
 			fielddisplay(obj,'penalty_factor','offset used by penalties: penalty = Kmax*10^offset');
 			fielddisplay(obj,'vertex_pairing','pairs of vertices that are penalized');
+			fielddisplay(obj,'requested_outputs','additional outputs requested');
 
 		end % }}}
@@ -66,4 +71,5 @@
 			WriteData(fid,'object',obj,'fieldname','vertex_pairing','format','DoubleMat','mattype',3);
 			WriteData(fid,'object',obj,'fieldname','penalty_factor','format','Double');
+			WriteData(fid,'object',obj,'fieldname','requested_outputs','format','DoubleMat','mattype',3);
 		end % }}}
 	end
Index: issm/trunk/src/m/classes/prognostic.py
===================================================================
--- issm/trunk/src/m/classes/prognostic.py	(revision 13405)
+++ issm/trunk/src/m/classes/prognostic.py	(revision 13975)
@@ -23,4 +23,5 @@
 		self.vertex_pairing         = float('NaN')
 		self.penalty_factor         = 0
+		self.requested_outputs      = float('NaN')
 
 		#set defaults
@@ -35,4 +36,5 @@
 		string="%s\n%s"%(string,fielddisplay(self,'hydrostatic_adjustment','adjustment of ice shelves surface and bed elevations: ''Incremental'' or ''Absolute'' '))
 		string="%s\n%s"%(string,fielddisplay(self,'stabilization','0->no, 1->artificial_diffusivity, 2->streamline upwinding, 3->discontinuous Galerkin'))
+		string="%s\n%s"%(string,fielddisplay(self,'requested_outputs','additional outputs requested'))
 
 		return string
@@ -67,4 +69,6 @@
 		md = checkfield(md,'prognostic.stabilization','values',[0,1,2,3])
 		md = checkfield(md,'prognostic.min_thickness','>',0)
+		if not md.prognostic.requested_outputs:
+			md = checkfield(md,'prognostic.requested_outputs','size',[float('NaN'),1])
 
 		return md
@@ -78,4 +82,5 @@
 		WriteData(fid,'object',self,'fieldname','vertex_pairing','format','DoubleMat','mattype',3)
 		WriteData(fid,'object',self,'fieldname','penalty_factor','format','Double')
+		WriteData(fid,'object',self,'fieldname','requested_outputs','format','DoubleMat','mattype',3);
 	# }}}
 
Index: issm/trunk/src/m/classes/qmu.m
===================================================================
--- issm/trunk/src/m/classes/qmu.m	(revision 13405)
+++ issm/trunk/src/m/classes/qmu.m	(revision 13975)
@@ -33,5 +33,5 @@
 		end % }}}
 		function obj = setdefaultparameters(obj) % {{{
-	
+
 		end % }}}
 		function md = checkconsistency(obj,md,solution,analyses) % {{{
@@ -142,5 +142,8 @@
 		function marshall(obj,fid) % {{{
 			WriteData(fid,'object',obj,'fieldname','isdakota','format','Boolean');
-			if ~obj.isdakota, return; end
+			if ~obj.isdakota, 
+				WriteData(fid,'data',false,'enum',QmuMassFluxSegmentsPresentEnum,'format','Boolean');
+				return; 
+			end
 			WriteData(fid,'object',obj,'fieldname','partition','format','DoubleMat','mattype',2);
 			WriteData(fid,'object',obj,'fieldname','numberofpartitions','format','Integer');
@@ -148,5 +151,11 @@
 			WriteData(fid,'object',obj,'fieldname','variabledescriptors','format','StringArray');
 			WriteData(fid,'object',obj,'fieldname','responsedescriptors','format','StringArray');
-			WriteData(fid,'object',obj,'fieldname','mass_flux_segments','format','MatArray');
+			if ~isempty(obj.mass_flux_segments), 
+				WriteData(fid,'data',obj.mass_flux_segments,'enum',MassFluxSegmentsEnum,'format','MatArray');
+				flag=true; 
+			else 
+				flag=false; 
+			end
+			WriteData(fid,'data',flag,'enum',QmuMassFluxSegmentsPresentEnum,'format','Boolean');
 		end % }}}
 	end
Index: issm/trunk/src/m/classes/qmu.py
===================================================================
--- issm/trunk/src/m/classes/qmu.py	(revision 13405)
+++ issm/trunk/src/m/classes/qmu.py	(revision 13975)
@@ -45,5 +45,4 @@
 		return self
 	#}}}
-
 	def checkconsistency(self,md,solution,analyses):    # {{{
 
@@ -68,5 +67,4 @@
 		return md
 	# }}}
-
 	def __repr__(self):    # {{{
 		s ='   qmu parameters:\n'
@@ -141,8 +139,8 @@
 		return s
 	# }}}
-		
 	def marshall(self,fid):    # {{{
 		WriteData(fid,'object',self,'fieldname','isdakota','format','Boolean')
 		if not self.isdakota:
+			WriteData(fid,'data',False,'enum',QmuMassFluxSegmentsPresentEnum(),'format','Boolean');
 			return
 		WriteData(fid,'object',self,'fieldname','partition','format','DoubleMat','mattype',2)
@@ -151,5 +149,10 @@
 		WriteData(fid,'object',self,'fieldname','variabledescriptors','format','StringArray')
 		WriteData(fid,'object',self,'fieldname','responsedescriptors','format','StringArray')
-		WriteData(fid,'object',self,'fieldname','mass_flux_segments','format','MatArray')
+		if not self.mass_flux_segments:
+			WriteData(fid,'data',self.mass_flux_segments,'enum',MassFluxSegmentsEnum(),'format','MatArray');
+			flag=True; 
+		else:
+			flag=False; 
+		WriteData(fid,'data',flag,'enum',QmuMassFluxSegmentsPresentEnum(),'format','Boolean');
 	# }}}
 
Index: issm/trunk/src/m/classes/results.py
===================================================================
--- issm/trunk/src/m/classes/results.py	(revision 13975)
+++ issm/trunk/src/m/classes/results.py	(revision 13975)
@@ -0,0 +1,59 @@
+import numpy
+from pairoptions import *
+from fielddisplay import *
+from MatlabFuncs import *
+from EnumDefinitions import *
+from WriteData import *
+
+class results(object):
+	"""
+	RESULTS class definition
+
+	   Usage:
+	      results=results();
+	"""
+
+	def __init__(self,*args):    # {{{
+		pass
+	# }}}
+
+	def __repr__(self):    # {{{
+		s ="   Model results:\n"
+
+		if 'step' in self.__dict__:
+			s+="%s\n" % fielddisplay(self,'step',"step number")
+		if 'time' in self.__dict__:
+			s+="%s\n" % fielddisplay(self,'time',"time value")
+		if 'SolutionType' in self.__dict__:
+			s+="%s\n" % fielddisplay(self,'SolutionType',"solution type")
+
+		for name in self.__dict__.iterkeys():
+			if name not in ['step','time','SolutionType','errlog','outlog']:
+				if   isinstance(getattr(self,name),list):
+					s+="%s\n" % fielddisplay(self,name,"model results list")
+				elif isinstance(getattr(self,name),results):
+					s+="%s\n" % fielddisplay(self,name,"model results case")
+				else:
+					s+="%s\n" % fielddisplay(self,name,"")
+
+		if 'errlog' in self.__dict__:
+			s+="%s\n" % fielddisplay(self,'errlog',"error log file")
+		if 'outlog' in self.__dict__:
+			s+="%s\n" % fielddisplay(self,'outlog',"output log file")
+
+		return s
+	# }}}
+
+	def setdefaultparameters(self):    # {{{
+		#do nothing
+		return self
+	# }}}
+
+	def checkconsistency(self,md,solution,analyses):    # {{{
+		return md
+	# }}}
+
+	def marshall(self,fid):    # {{{
+		pass
+	# }}}
+
Index: issm/trunk/src/m/classes/rifts.m
===================================================================
--- issm/trunk/src/m/classes/rifts.m	(revision 13405)
+++ issm/trunk/src/m/classes/rifts.m	(revision 13975)
@@ -38,8 +38,10 @@
 					md = checkmessage(md,['model should be processed for rifts (run meshprocessrifts)!']);
 				end
-				md = checkfield(md,'rifts.riftstruct.fill','values',[WaterEnum() AirEnum() IceEnum() MelangeEnum()]);
+				for i=1:numrifts,
+					md = checkfield(md,sprintf('rifts.riftstruct(%d).fill',i),'values',[WaterEnum() AirEnum() IceEnum() MelangeEnum()]);
+				end
 			else
 				if ~isnans(obj.riftstruct),
-					md = checkmessage(md,['riftstruct shoud be NaN since numrifts is 0!']);
+					md = checkmessage(md,['riftstruct should be NaN since numrifts is 0!']);
 				end
 			end
